<?php

use App\Enums\StudentStatus;
use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    public function up(): void
    {
        Schema::create('students', function (Blueprint $table) {
            $table->id();
            $table->foreignId('user_id')->constrained()->cascadeOnDelete();
            $table->string('student_number', 10)->unique();
            $table->foreignId('department_id')->constrained()->cascadeOnDelete();
            $table->integer('enrollment_year');
            $table->unsignedTinyInteger('current_semester')->default(1);
            $table->foreignId('academic_advisor_id')->nullable()->constrained('lecturers')->nullOnDelete();
            $table->enum('status', StudentStatus::values())->nullable()->default(StudentStatus::Active->value);
            $table->timestamps();
            $table->softDeletes();
        });
    }

    public function down(): void
    {
        Schema::dropIfExists('students');
    }
};
